﻿;	--	GUI creation

Gui, 1: New, , LvL2img - Lemmings Levels & Packs GUI Converter
Gui, color, white
Gui, Add, Picture, , %A_WorkingDirectory%\LvL2img.png		;	--	Program logo
Gui, Add, Text, xp+300 yp+5, Drag and drop LVL && NXP files to the window and press 
Gui, Add, Button, xp+267 yp-4 w60 vBeginButton gBegin, Begin	;	--	WHERE EVERYTHING STARTS!
Gui, Add, Text, x353 y60 vTotalProgressText, Total progress:
Gui, Add, Progress, x430 y58 vTotalProgress w300	;	--	Progress bar (hidden at the beggining, as well as the text before it)
HideProgressControls()	;	--	Hide the progress controls before the GUI is showed
;	--	Select and deselect buttons
Gui, Add, Button, x10 y76 w90 vSelectAllButton gSelectAll, Select all
Gui, Add, Button, x105 y76 w90 vDeselectButton gDeselect, Deselect
;	--	Cleaning list of files button
Gui, Add, Text, x200 y82 vFilesToTreat, 0 File(s) on the list
Gui, Add, Button, x781 y76 w70 vCleanListButton gCleanList, Clean List
;	--	List of files to process - it updates itself when files are dragged and dropped into the GUI window
Gui, Add, ListView, x10 y100 r15 w840 vListOfCurrentFiles, Archive | Size | Status | Observations
Gui, Add, Button, x377 y396 w127 vOutputFolderButton gSelectOutputFolder, Output Folder
;	--	Output folder selection for compressed/converted files
Gui, Add, Edit, ReadOnly r1 xp+130 yp+1 w200 vSelectedOutputFolder, %A_ScriptDir%
Gui, Add, Checkbox, xp+210 yp+4 vSameDirOrNot gSameDirOrNot, Same as input
Gui, Show, h430 w860
return

;	--	Actions and functions directly related with GUI interaction of the user

IsOnList(NameOfTheFile)		;	--	Verify if a dragged and dropped file is already on the list
{
	Loop % LV_GetCount()
	{
		LV_GetText(RetrievedText, A_Index)
		if(NameOfTheFile=RetrievedText)
			return 1
	}
	return 0
}

HideProgressControls()
{
	GuiControl, Hide, TotalProgressText
	GuiControl, Hide, TotalProgress
}

ShowProgressControls()
{
	GuiControl, Show, TotalProgressText
	GuiControl,, TotalProgress, 0	;	--	"0" means that the progress bar will be initialized totally empty
	GuiControl, Show, TotalProgress
}

DeactivateInteractionControls()	;	--	While the program is running, this buttons and controls are disable
{
	GuiControl, Disable, BeginButton
	GuiControl, Disable, SelectAllButton
	GuiControl, Disable, DeselectButton
	GuiControl, Disable, CleanListButton
	GuiControl, Disable, ListOfCurrentFiles
	GuiControl, Disable, OutputFolderButton
	GuiControl, Disable, SelectedOutputFolder
	GuiControl, Disable, SameDirOrNot
}

ActivateInteractionControls()	;	--	Enable interaction controls
{
	GuiControl, Enable, BeginButton
	GuiControl, Enable, SelectAllButton
	GuiControl, Enable, DeselectButton
	GuiControl, Enable, CleanListButton
	GuiControl, Enable, ListOfCurrentFiles
	GoSub CheckBoxSelectedOutputFolder	;	--	In order to know whether to activate or not the box and the output folder selection controls, we verify the SameDirOrNot check box
	GuiControl, Enable, SameDirOrNot
}

ChangeButtonNames: 	;	--	The following code replaces the "Yes/No" text of an alert window with custom text (it's quicker than create an aditional and customized GUI)
IfWinNotExist, Clean the List
    return  ; Keep waiting.
SetTimer, ChangeButtonNames, off 
WinActivate 
ControlSetText, Button1, &Selected
ControlSetText, Button2, &Whole List
return

GuiDropFiles:	;	--	Behaviour of the program when files are dragged and dropped to the window
GuiControlGet, ListViewState, Enabled, ListOfCurrentFiles	;	--	Check the status of the list of files control (if is 0, then no drag and drop to the window is allowed)
if(ListViewState=1) and (ProgramReadyToBeUsed=1)
{
	FileList = %A_GuiEvent%	;	--	Detect the list of files dragged and dropped to the window
	Sort, FileList	;	--	Order the list of dropped files
	Loop, parse, FileList, `n	;	--	Loop through the dropped files in order to collect info about them
	{
		NameOfFile:=A_LoopField	;	--	Get route of current file on the list of dropped ones
		SplitPath, NameOfFile, , , ExtensionOfCurrentFile
		if(IsOnList(NameOfFile)=0) and ((ExtensionOfCurrentFile="lvl") or (ExtensionOfCurrentFile="nxp"))	;	--	Files with extension different than LVL or NXP ARE not allowed to be dropped into the GUI
		{
			FileGetSize, SizeOfFile, %NameOfFile%, K
			LV_Add("", NameOfFile, SizeOfFile " KB", "Pending", ExtensionOfCurrentFile " File")
		}
	}
	LV_ModifyCol()  ; Auto-size columns to fit its contents.
			LV_ModifyCol(2, "100 Integer")  ; For sorting purposes, indicate that this column is an integer. The width of it will be 100 px
			LV_ModifyCol(3, "80 Text")  ; For sorting purposes, indicate that this column is an integer. The width of it will be 80 px
			LV_ModifyCol(4, "80 Text")  ; For sorting purposes, indicate that this column is text. The width of it will be 80 px
	GuiControl,, FilesToTreat, % LV_GetCount() " CurrentFile(s) on the list"	;	--	Update the text info about the total number of files on the list
}
return

SelectAll:	;	--	Select all the rows on the list
LV_Modify(0, "Select")
return

Deselect:	;	--	Deselect row(s) on the list
LV_Modify(0, "-Select")
return

CleanList:	;	--	Clean the list of files
if(ProgramReadyToBeUsed=1)	;	--	If the program have not started yet, we clean as usual when we click the Clean List button
{
	if(LV_GetCount("Selected")=0)
	{
		LV_Delete()	;	--	Clean the whole list
	}
	else
	{
		SetTimer, ChangeButtonNames, 50
		MsgBox, 8195, Clean the List, Do you want to clean the selected files, or the whole list?	;	8195 = 3 (3 buttons) + 8192 (TaskModal)
		IfMsgBox Yes
		{
			GoSub CleanSelectedRows	;	--	Clean selected rows
		}
		IfMsgBox No
		{
			LV_Delete()	;	--	Clean the whole list
		}
	}
}
else	;	--	If the program have finished to compress/convert the files, then we prepare the program to start again when we click the Clean List button
{
	HideProgressControls()
	ActivateInteractionControls()
	LV_Delete()	;	--	Clean the whole list
	ProgramReadyToBeUsed:=1
}
GuiControl,, FilesToTreat, % LV_GetCount() " File(s) on the list"	;	--	Update number of files on the list
return

CheckBoxSelectedOutputFolder:
GuiControlGet, CheckBoxState,, SameDirOrNot
if(CheckBoxState=1)
{
	GuiControl, Disable, OutputFolderButton
	GuiControl, Disable, SelectedOutputFolder
}
else
{
	GuiControl, Enable, OutputFolderButton
	GuiControl, Enable, SelectedOutputFolder
}
return

SameDirOrNot:	;	--	The output folder of the processed files can be the same as the input file, or a selected one - it depends on a checkbox in the GUI
GuiControlGet, CheckBoxState,, SameDirOrNot
if(CheckBoxState=1)
{
	GuiControl, Disable, OutputFolderButton
	GuiControl, Disable, SelectedOutputFolder
	LastSelectedFolder:=SelectedOutputFolder
	SelectedOutputFolder = Same
}
else
{
	GuiControl, Enable, OutputFolderButton
	GuiControl, Enable, SelectedOutputFolder
	SelectedOutputFolder:=LastSelectedFolder
}
return

SelectOutputFolder:	;	--	Select an output folder for the processed files
FileSelectFolder, Folder, , , Select an output folder:
if Folder =		; 	--	If no folder is selected, nothing is changed, and the SelectedOutputFolder will be the last one selected before (or by default)
{
	return
}
else
{
	GuiControl,, SelectedOutputFolder, %Folder%
	SelectedOutputFolder:=Folder
	LastSelectedFolder:=SelectedOutputFolder
}
return

;	--	The following actions and buttons will only work if the focused window is the current GUI

#IfWinActive LvL2img - Lemmings Levels & Packs GUI Converter

Delete::	;	--	Keyboard "Del" button
CleanSelectedRows:
;	--	Delete selected rows
if(ProgramReadyToBeUsed=1)
{
	if(LV_GetCount("Selected")>0)
	{
		NumberOfSelectedRow:=0
		ArrayOfSelectedFiles:=[]
		Loop 
		{
			NumberOfSelectedRow:=LV_GetNext(NumberOfSelectedRow)
			if not NumberOfSelectedRow
			{
				break
			}
			ArrayOfSelectedFiles.InsertAt(1, NumberOfSelectedRow)
		}
		Loop % ArrayOfSelectedFiles.Length()
		{
			LV_Delete(ArrayOfSelectedFiles[A_Index])
		}
		GuiControl,, FilesToTreat, % LV_GetCount() " File(s) on the list"	;	--	Update number of files on the list
	}
}
return

;	--	Exit and close program
Esc::	;	--	Keyboard "Esc" button
GuiClose:	;	--	X button (the closing one) of the window
if(AllowClosingProgram=1)
{
	ExitApp
}
else
{
	MsgBox, 8452, Close the program, The program is still converting files.`nAre you sure you want to close it?	; 8452:= 4 (Yes/No buttons) + 256 (2nd button selected by default) + 8192 (window always on top)
	IfMsgBox Yes
	{
		SplashTextOn, , , Exiting program...
		SplashTextOff
		AllowClosingProgram:=1
		ExitApp
	}
}